﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Data;
using System.Data.OleDb;
using System.Web.Script.Services;
using System.Collections;
using System.Web.Script.Serialization;
using System.Text;
[ScriptService]
[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
// To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
// [System.Web.Script.Services.ScriptService]
[Serializable]
public class CategoryService : System.Web.Services.WebService
{
    public CategoryService()
    {

        //Uncomment the following line if using designed components 
        //InitializeComponent(); 
    }  

    [WebMethod(Description="Returns array of countries for a given continent.")]
    [ScriptMethod(ResponseFormat = ResponseFormat.Json)]
		public string[] GetCountries(string continent)
 		{
			Hashtable ht = new Hashtable();
     
			ht.Add("Europe", new string[] {"UK", "France", "Germany"});
			ht.Add("Africa", new string[] {"South Africa", "Zimbabwe", "Cameroon"});
			ht.Add("North America", new string[] {"USA", "Canada"});           
            return (string[])ht[continent];          
 		}

    [WebMethod]
    [ScriptMethod(UseHttpGet = true, ResponseFormat = ResponseFormat.Json)]
    public string GetJsonCategories()
    {        
        DataTable dtCategories = CreateData("Categories");
     
        Dictionary<string, object> resultMain = new Dictionary<string, object>();
        int index = 0;

        foreach (DataRow dr in dtCategories.Rows)
        {
            Dictionary<string, object> result = new Dictionary<string, object>();

            foreach (DataColumn dc in dtCategories.Columns)
            {
                result.Add(dc.ColumnName, dr[dc].ToString());
            }
            resultMain.Add(index.ToString(), result);
            index++;
        }

        StringBuilder objSb = new StringBuilder();
        JavaScriptSerializer objSer = new JavaScriptSerializer();

        return objSer.Serialize(resultMain.Values);
    }    

    private DataTable CreateData(string tableName)
    {
        DataTable dtData = new DataTable();

        // Do not forget to change the connection string  
        // to access your local database
        string connString = @"Provider=Microsoft.Jet.OLEDB.4.0;" +
        @"Data Source=|DataDirectory|\Northwind.mdb;" +
        @"Persist Security Info=True";

        OleDbConnection oleDbConn = new OleDbConnection(connString);

        // I put the [] brackets because "Order" is reserved word in SQL
        String cmdText = "SELECT * FROM [" + tableName + "]";
        // Select all columns from the table
        OleDbCommand oleDbComm = new OleDbCommand(cmdText, oleDbConn);

        // Create the adapter 
        OleDbDataAdapter oleDataAdapter = new OleDbDataAdapter(oleDbComm);

        // Fill the data table and return it

        oleDataAdapter.Fill(dtData);
        return dtData;
    }
    
}